
%% a couple of DLP built-in's

:-object pxbins.

var i := 0, j := abc, k := f(a,b).

main(Argv) :-
	format('~nmain/1 arguments: ~w~n', [Argv]),

	ArgList = [q,w,e,r,t,y],
	arg(1, ArgList, Head),
	format('arg/3: ~w 1st arg: ~w~n', [ArgList,Head]),
	arg(2, ArgList, Tail),
	format('arg/3: ~w 2nd arg: ~w~n', [ArgList,Tail]),

	ArgComp = f(a,b,c),
	arg(1, ArgComp, ArgV1),
	format('arg/3: ~w 1st arg: ~w~n', [ArgComp,ArgV1]),
	arg(2, ArgComp, ArgV2),
	format('arg/3: ~w 2nd arg: ~w~n', [ArgComp,ArgV2]),
	arg(3, ArgComp, ArgV3),
	format('arg/3: ~w 3rd arg: ~w~n', [ArgComp,ArgV3]),

	%% arithmetic comparison operators:
	11 < 22, format('compare: ~w < ~w~n', [11, 22]),
	22 > 11, format('compare: ~w > ~w~n', [22, 11]),
	33 =< 33, format('compare: ~w =< ~w~n', [33, 33]),
	44 >= 11, format('compare: ~w >= ~w~n', [44, 11]),
	55 =:= 11+44, format('compare: ~w =:= ~w~n', [55, 55]),
	66 =\= 22+55, format('compare: ~w =\\\\= ~w~n', [66, 77]),

	ABC=abc, NIL=[], atom(ABC), atom(NIL),
	format('atom/1: ~w and ~w are atoms~n', [ABC,NIL]),

	atom_chars(ABC, ABCchars),
	format('atom_chars/2: ~w atom chars are ~w~n', [ABC,ABCchars]),
	atom_codes(ABC, ABCcodes),
	format('atom_codes/2: ~w atom codes are ~w~n', [ABC,ABCcodes]),

	ABC = ABC,
	format('=/2: ~w and ~w unify~n', [ABC, ABC]),
	ABCchars = ABCchars,
	format('=/2: ~w and ~w unify~n', [ABCchars, ABCchars]),
	ABCcodes = ABCcodes,
	format('=/2: ~w and ~w unify~n', [ABCcodes, ABCcodes]),

	atom_chars(ABC, ABCchars), %% unify ABCchars
	format('atom_chars/2: ~w atom list is atom ~w~n', [ABCchars, ABC]),
	atom_codes(ABC, ABCcodes), %% unify ABCcodes
	format('atom_codes/2: ~w code list is atom ~w~n', [ABCcodes, ABC]),

	atom_length(ABC, ABClength),
	format('atom_length/2: atom ~w has length ~w~n', [ABC, ABClength]),
	atomic(ABC),
	format('atomic/1: ~w is atomic~n', [ABC]),

	atom_concat(abc, def, Cat),
	format('atom_concat/3: ~w + ~w = ~w~n', [abc, def, Cat]),

	CatList = [a,b,c,d,e,f],
	atom_list_concat(CatList, CatAtom),
	format('atom_list_concat/3: ~w ==> ~w~n', [CatList, CatAtom]),

	Achar = a,
	char_code(Achar, Acode),
	format('char_code/2: code of char ~w is ~w~n', [Achar, Acode]),

	Comp = f(a,b,c), List = [q,w,e],
	compound(Comp), compound(List),
	format('compound/1: ~w and ~w are both compound~n', [Comp,List]),

	TermOrig = f(AA,g(AA),BB,[BB]),
	copy_term(TermOrig, TermCopy),
	format('copy_term/2: the copy of~n ~w is~n ~w~n', [TermOrig, TermCopy]),

	Delay = 1000,
	format('sleep/1: ~w msecs~n', [Delay]),
	sleep(Delay),

	format('display/1: ~w display : ', [ABCchars]),
	display(ABCchars), nl,

	Float = 12.34,
	float(Float),
	format('float/1: ~w is a float~n', [Float]),

	format('~n'),
	Func11 = f(q,w,e),
	functor(Func11,Name1,Argc1),
	format('functor/3: func=~w ==> name=~w, argc=~w~n', [Func11,Name1,Argc1]),
	functor(Func12,Name1,Argc1),
	format('functor/3: name=~w, argc=~w ==> func=~w~n', [Name1,Argc1,Func12]),

        functor([qwerty], Name2, Argc2),
	format('functor/3: func=~w ==> name=~w, argc=~w~n', [[qwerty],Name2,Argc2]),
	functor(Func22, '.', 2),
	format('functor/3: name=~w, argc=~w ==> func=~w~n', ['.', 2, Func22]),

	functor(Float, Name3, Argc3),
	format('functor/3: func=~w ==> name=~w, argc=~w~n', [Float,Name3,Argc3]),

	Ground  = [Delay, Float, ABC, NIL, Func11, [qw, er, ty]],
	format('~nground/1: ~w~n', [Ground]),

	Integer = 12345,
	integer(Integer),
	format('integer/1: ~w is an integer~n', [Integer]),

	format('~n',[]),
	Exp1 = 1 + 2 - 3 * 4 // 5,
	Res1 is Exp1,
	format('is/2: ~w is ~w~n', [Res1, Exp1]),
	Exp2 = 1 + 2 - 3 * 4 / 5,
	Res2 is Exp2,
	format('is/2: ~w is ~w~n', [Res2, Exp2]),
	Exp3 = 4 mod 3 << 2 >> 1,
	Res3 is Exp3,
	format('is/2: ~w is ~w~n', [Res3, Exp3]),

	Res4 is Res1 + 1,
	format('is/2 (inline): ~w => ~w~n', [Res1, Res4]),
	Res5 is Res2 + 1,
	format('is/2 (inline): ~w => ~w~n', [Res2, Res5]),
	Res6 is Res4 - 1,
	format('is/2 (inline): ~w <= ~w~n', [Res6, Res4]),
	Res7 is Res5 - 1,
	format('is/2 (inline): ~w <= ~w~n', [Res7, Res5]),

	NameAtom = 'n_a_m_e',
	name(NameAtom,NameCode),
	format('name/2: ~q <=> ~w~n', [NameAtom,NameCode]),

	nonvar(Integer), nonvar(ABC), nonvar(Float),
	format('nonvar/1: ~w, ~w, ~w are nonvar~n', [Integer,ABC,Float]),

	number(Integer), number(Float),
	format('number/1: and ~w, ~w are numbers~n', [Integer, Float]),

	nl,
	number_chars(Integer, IntChars),
	format('number_chars/2: ~q is char list ~q~n', [Integer, IntChars]),
	number_codes(Integer, IntCodes),
	format('number_codes/2: ~q is code list ~q~n', [Integer, IntCodes]),

	nl,
	number_chars(IntNum, IntChars), integer(IntNum),
	format('number_chars/2: char list ~q is integer ~q~n', [IntChars, IntNum]),
	number_codes(IntNum, IntCodes), integer(IntNum),
	format('number_codes/2: code list ~w is integer ~q~n', [IntCodes, IntNum]),

	nl,
	number_chars(Float, FltChars),
	format('number_chars/2: ~q is char list ~q~n', [Float, FltChars]),
	number_codes(Float, FltCodes),
	format('number_codes/2: ~q is code list ~q~n', [Float, FltCodes]),

	nl,
	number_chars(FltNum, FltChars), float(FltNum),
	format('number_chars/2: char list ~q is float ~q~n', [FltChars, FltNum]),
	number_codes(FltNum, FltCodes), float(FltNum),
	format('number_codes/2: code list ~q is float ~q~n', [FltCodes, FltNum]),

	var(Var),
	format('var/1: ~w is var~n', [Var]),

	nl, write('nl/0, tab/1, write/1, writeq/1 (instead of format/2) for the'),
	nl, write('number_chars/2 of '),
	write(Float), tab(1), write('is'), tab(1), writeq(FltChars), nl,

	true.

:-end_object pxbins.
