
%% sema:counter:intnum object hierarchy

:-object intnum.
	var nr = 0.

	incr_nr :- ++nr.
	decr_nr :- --nr.

	this_nr(N) :- N := nr.

	intnum(N) :-
		nr := N // 2,
		shared(N).

	shared(0).
	shared(I) :-
		N is I - 1,
		accept(decr_nr, incr_nr, this_nr(_)),
		shared(N).

:-end_object intnum.


:-object counter : [intnum].
	incr :- incr_nr.
	decr :- decr_nr.
:-end_object(counter).


:-object sem0 : [counter].

	p :- incr.
	v :- decr.

	sem0(0).
	sem0(I) :-
		N is I - 1,
		this_nr(NR),
		( NR =:= 0 ->
			accept(p)
		;
			accept(v)
		),
		sem0(N).
:-end_object(sem0).


:-object sem1.
	var ns = 0.

	p :- ns := 1.
	v :- ns := 0.

	sem1(N) :-
		init(N).

	init(0).
	init(I) :-
		( ns =:= 0 ->
			accept(p)
		;
			accept(v)
		),
		N is I - 1,
		init(N).

:-end_object(sem1).


:-object sem2.

	var ns = 0.

	p :- ns := 1.
	v :- ns := 0.

	sem2(0).
	sem2(I) :-
		N is I - 1,
		accept(p <== [ns =:= 0], v <== [ns =:= 1]),
		sem2(N).

:-end_object(sem2).


:-object sem3.

	var ns = 0.

	p_body :-
		ns := 1.
	v_body :-
		ns := 0.

	sem3(N) :-
		init(N).

	init(0).
	init(I) :-
		accept(	p <== [ns =:= 0] ==> ns := 1,
			v <== [ns =:= 1] ==> ns := 0
		),
		N is I - 1,
		init(N).

:-end_object(sem3).



:-object decr.

	loop(0,_,_).
	loop(I,PV,IN) :-
		N is I - 1,
		PV <- p,
		IN <- decr_nr,
		IN <- this_nr(NR),
		format('~w: shared number = ~w~n', [this, NR]),
		( N mod 3 =:= 0 ->
			format('~w: delay(1000), non-shared number ~w~n', [this,N]),
			delay(1000)	%% Check whether other threads block
		;
			true
		),
		PV <- v,
		loop(N,PV,IN).

	decr(N,PV,IN) :-
		loop(N,PV,IN).

:-end_object decr.


:-object pxsema.

	main :-
		IN := new(intnum(80)),
		PV := new(sem0(80)),	%% ok
		%% PV := new(sem1(80)),	%% ok
		%% PV := new(sem2(80)),	%% ok
		%% PV := new(sem3(80)),	%% ok
		I1 := new(decr(10,PV,IN)),
		I2 := new(decr(10,PV,IN)),
		I3 := new(decr(10,PV,IN)),
		I4 := new(decr(10,PV,IN)),
		true.

:-end_object pxsema.

